/*
 * Copyright (c) 2017 SpaceToad and the BuildCraft team
 * This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not
 * distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/
 */

package buildcraft.lib.inventory.filter;

import javax.annotation.Nonnull;

import net.minecraft.item.ItemStack;

import buildcraft.lib.misc.StackUtil;

/** Returns true if the stack matches any one one of the filter stacks. Takes into account item lists. */
public class ArrayStackOrListFilter extends ArrayStackFilter {

    public ArrayStackOrListFilter(ItemStack... stacks) {
        super(stacks);
    }

    @Override
    public boolean matches(@Nonnull ItemStack stack) {
        if (stacks.size() == 0 || !hasFilter()) {
            return true;
        }

        for (ItemStack s : stacks) {
            if (StackUtil.isMatchingItemOrList(s, stack)) {
                return true;
            }
        }

        return false;
    }
}
